from collections import deque
import numpy as np

dxdy = [(0,1),(1,0),(0,-1),(-1,0)]

def dfs(image):
    """
    returns cluster number array
    """
    h,w = image.shape[:2]
    # create masks
    ret = np.zeros((h,w))
    cluster = 0
    cnt = []
    for i in range(h):
        for j in range(w):
            if image[i][j]:
                cluster += 1
                cnt_tmp = 0
                que = deque()
                que.append((i,j))
                while que:
                    x,y = que.popleft()
                    if image[x][y] == 0:continue
                    image[x][y] = 0
                    cnt_tmp += 1
                    ret[x][y] = cluster
                    for dx,dy in dxdy:
                        nx,ny = x+dx, y+dy
                        if 0<=nx<h and 0<=ny<w and image[nx][ny]:
                            que.append((nx,ny))
                cnt.append(cnt_tmp)
    return cluster, cnt, ret