import torch
import torchvision
from torchvision.transforms import Compose, ToTensor, Normalize, Resize

from torchvision.models.segmentation import deeplabv3_resnet101 as m
model = m(True)
model.eval()

k = ['__background__', 'aeroplane', 'bicycle', 'bird', 'boat', 'bottle', 'bus',
'car', 'cat', 'chair', 'cow', 'diningtable', 'dog', 'horse', 'motorbike',
'person', 'pottedplant', 'sheep', 'sofa', 'train', 'tvmonitor']
person = k.index("person")

device = "cuda:0"
model.to(device)

from PIL import Image
from util.utils import resize_shape
import cv2

# deeplab-v3 (resnet101)
def get_segment(p, H=-1,W=-1):
    image = cv2.imread(p)
    image = cv2.cvtColor(image, cv2.COLOR_BGR2RGB)
    image = Image.fromarray(image)
    w,h = image.size
    H,W = resize_shape(h,w)

    transform = Compose([Resize((H, W)),ToTensor(), Normalize(mean=(0.485, 0.456, 0.406), std=(0.229, 0.224, 0.225))])
    image = transform(image)
    image = image.to(device)
    batch = torch.unsqueeze(image,0)

    out = model(batch)
    person_tensor = out["out"][0][person].cpu().detach().numpy()

    return person_tensor