from get_segment import get_segment
from util.utils import resize_shape
import numpy as np
import cv2
from get_face import get_bbox, bboxes2mask, bboxes2mask2
from dfs import dfs


from util.imageinfo import get_image_size
from glob import glob
import os
# path to photo folder
files = glob("../data/photos/**/*", recursive=True)
ps = []
for file in files:
    if "." in file and file.split(".")[-1] in ['jpg', 'JPG', 'jpeg', 'png', 'Jpeg', 'JPEG']:
        ps.append(file)

for p in ps:
    try:
        target = p
        for ex in ['JPG', 'jpeg', 'Jpeg', 'JPEG']:
            target = target.replace("."+ex, ".jpg")
        target = target.replace(".jpg", "_blur.jpg")
        target = target.replace(".png", "_blur.jpg")
        target = target.replace("video", "blur")
        if os.path.exists(target):
            continue

        # get body area
        person_numpy = get_segment(p)
        k = 7.5
        person_numpy = np.where(person_numpy < k, 0, 255)

        no_mask = np.where(person_numpy < k, 255, 0)
        no_mask = np.stack((no_mask,)*3, axis=-1)
        no_mask = np.uint8(no_mask)

        segment_mask = np.uint8(np.where(no_mask==0, 255, 0))

        img = cv2.imread(p)
        h,w,*_ = img.shape
        
        k = max(h,w) / min(h,w)
        if k > 2:
            continue

        H,W = resize_shape(h,w)
        img = cv2.resize(img, (W,H))
 
        img2 = cv2.bitwise_and(img, no_mask)

        # 1st stage : blur body area
        m = 100
        k = W//m
        k += 1-k%2
        dst = cv2.GaussianBlur(img, (k,k),0)
        dst2 = cv2.bitwise_and(dst, segment_mask)

        ret1 = img2 + dst2

        # get face area
        bboxes, coff = get_bbox(p)
        print(bboxes)
        bbox_mask = bboxes2mask2(bboxes, H,W)

        noface_mask = np.where(bbox_mask==1, 0, 255)
        noface_mask = np.stack((noface_mask,)*3, axis=-1)
        noface_mask = np.uint8(noface_mask)

        face_mask = np.where(bbox_mask==1, 255, 0)
        face_mask = np.stack((face_mask,)*3, axis=-1)
        face_mask = np.uint8(face_mask)

        cluster, cnt, colored_mask = dfs(bbox_mask)

        blured = np.zeros((H,W,3), dtype=np.uint8)
        for i in range(cluster):
            mask = np.where(colored_mask==i+1, 255, 0)
            mask = np.stack((mask,)*3, axis=-1)
            mask = np.uint8(mask)
            # change blur depending on face size
            p = cnt[i]/(W*H)
            if p < 0.001:
                m = 50
            elif p < 0.01:
                m = 25
            elif p < 0.04:
                m = 16
            else:
                m = 11
            k = W//m
            k += 1-k%2
            dst = cv2.GaussianBlur(img, (k,k), 0)
            dst = cv2.bitwise_and(dst, mask)
            blured += dst

        noface = cv2.bitwise_and(noface_mask, ret1)
        face = cv2.bitwise_and(face_mask, blured)

        ret2 = noface+face
        # mkdir
        d = os.path.dirname(target)
        os.makedirs(d, exist_ok=True)
        cv2.imwrite(target, ret2)
    except:
        pass